function [out,out2]=Atridiag(v,flag,gamma)

global MyPrecond_L MyPrecond_U

n=100; out2=[];
if nargin<3, gamma=0; end
ok=3;  %% several ways of calling the subroutines

if nargin > 1

 if ok==1
  switch flag
  case 'dimension'
    SetPrecond(n); out=n; return 
  case 'preconditioner'
    out=Minv(v,n,gamma); return
  case ''
  otherwise, error('unknown argument')
  end
 end

 if ok==2
  switch flag
  case 'dimension'
    SetPrecond(n); out=n; return 
  case 'A', out=A(v,n); return
  case 'B', out=B(v,n); return
  case 'preconditioner'
    out=Minv(v,n,gamma); return
  otherwise, error('unknown argument')
  end
 end

 if ok==3
  switch flag
  case 'dimension'
    SetPrecond(n); out=n; return 
  case 'A', out=A(v,n); return
  case 'B', out=B(v,n); return 
  case 'L'
    out=MyPrecond_L\v; return
  case 'U'
    out=MyPrecond_U\v; return
  otherwise, error('unknown argument')
  end
 end

end

  out=A(v,n);
  out2=B(v,n);

return
%----------------------------------------------
function out=A(v,n)

  i1=1:n-2; i2=2:n;
  w(i1+2,:)=v(i1,:);
  w(i2-1,:)=w(i2-1,:)+v(i2,:);
  out=w-2*v;

return
%----------------------------------------------
function out=B(v,n)

  d=(2:n+1)'; d=d*ones(1,size(v,2));
  out=d.*v;

return
%----------------------------------------------
function out=Minv(v,n,gamma)
global MyPrecond

  if gamma
    out=MyPrecond\v;
  else
    d=(2:n+1)'; d=d*ones(1,size(v,2));
    out=d.\v;
  end

return
%----------------------------------------------
function SetPrecond(n)
global MyPrecond MyPrecond_L MyPrecond_U

  e=ones(n,1);  o=zeros(n,1);
   MyPrecond = spdiags([-2*e e],0:1,n,n); 
 
   MyPrecond_U = spdiags([-2*e e],0:1,n,n);  
   MyPrecond_L = speye(n,n);  

   MyPrecond_L = spdiags([-0.5*e o e],-2:0,n,n);  %% SSOR

   %% A=spdiags([e o -2*e e],-2:1,n,n);
   %% [MyPrecond_L,MyPrecond_U]=lu(A);
return
%----------------------------------------------

